#!/usr/bin/env ruby

require 'curses'
#require './LegacyGraphics'
#require './TrueLegacyGraphics'
#require './TrueLegacyGraphicsGtk2'
require './TrueLegacyGraphicsCairo'

require 'optparse'
opt_size = opt_origin = opt_step = opt_remove_inner = opt_join_inner = opt_one_stroke = nil
opts = OptionParser.new
opts.version = '1.00'; opts.release = 'a'
opts.banner = "Usage: ./cutDotPat.rb [options] [imagefile]"
opts.on('-s', '--size x,y',						'sample size.')				{|p| opt_size			= p }
opts.on('-O', '--origin x,y',					'sample origin.')			{|p| opt_origin			= p }
opts.on('-S', '--step x,y',						'sample step.')				{|p| opt_step			= p }
opts.on('-l', '--remove-inner',					'remove inner lines.')		{|p| opt_remove_inner	= true }
opts.on('-j', '--join-inner',					'join inner lines.')		{|p| opt_join_inner		= true }
opts.on('-o', '--one-stroke',					'one stroke.')				{|p| opt_one_stroke		= true }
params = opts.permute(ARGV)

Curses.init_screen if($curses_enable)			# screen 3 (^_^;)
winX = Curses.cols  - 0
winY = Curses.lines - 0
# for A4 - 144dpi - 210mm x 297mm - (上下左右の余白 4.23mm)
#win = LegacyGraphics.new(winY, winX, 0, 0, 1635, 1142, 16, 8, 7, { :file => 'cutdotpat', :type => 'pdf' })		# png/pdf/svg/ps
# for ScanNCut CM110 - 72dpi - 296mm x 298mm(603mm)
win  = LegacyGraphics.new(winY, winX, 0, 0,  838,  844, 16, 8, false, { :file => 'cutdotpat', :type => 'svg' })	# png/pdf/svg/ps
# for Speedy 100 - 72dpi - 610mm x 305mm
#win = LegacyGraphics.new(winY, winX, 0, 0, 1729,  864, 16, 8, false, { :file => 'cutdotpat', :type => 'svg' })	# png/pdf/svg/ps
win.clear; win.box('|', '-')					# cls

pat = [
	[9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9],
	[9, 9, 9, 9, 9, 9, 2, 2, 2, 2, 9, 9, 9, 9, 9, 9],
	[9, 9, 9, 9, 2, 2, 2, 2, 2, 2, 2, 2, 9, 9, 9, 9],
	[9, 9, 9, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 9, 9, 9],
	[9, 9, 2, 2, 2, 7, 7, 2, 2, 2, 2, 7, 7, 2, 9, 9],
	[9, 9, 2, 2, 7, 7, 7, 7, 2, 2, 7, 7, 7, 7, 9, 9],
	[9, 9, 2, 2, 7, 7, 1, 1, 2, 2, 7, 7, 1, 1, 9, 9],
	[9, 2, 2, 2, 7, 7, 1, 1, 2, 2, 7, 7, 1, 1, 2, 9],
	[9, 2, 2, 2, 2, 7, 7, 2, 2, 2, 2, 7, 7, 2, 2, 9],
	[9, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 9],
	[9, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 9],
	[9, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 9],
	[9, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 9],
	[9, 2, 2, 9, 2, 2, 2, 9, 9, 2, 2, 2, 9, 2, 2, 9],
	[9, 2, 9, 9, 9, 2, 2, 9, 9, 2, 2, 9, 9, 9, 2, 9],
	[9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9],
]

class String
	def to_ia
		r = []; self.split(/[,x+:]/).each {|ns|
			r << ns.to_i
		}
		r
	end
end

if(file = params[0])
	origin	= (it = opt_origin)	? it.to_ia : [0, 0]
	size	= (it = opt_size)	? it.to_ia : LegacyGraphics.get_image_size_png(file)
	step	= (it = opt_step)	? it.to_ia : [1, 1]
	pat = win.get(*origin, *size, file, *step) {|c|
		c.opacity > 0 ? 9 : (c.green > 0x7FFF ? 4 : 0) + (c.red > 0x7FFF ? 2 : 0) + (c.blue > 0x7FFF ? 1 : 0)
	}
end
pat.each {|hpat| puts("#\t%s,\n" % hpat.inspect) }

class Grid < Hash

	def initialize(d)
		@dx = (d == :H) ? 1 : 0
		@dy = (d == :H) ? 0 : 1
	end

	def set(x, y, c = 7)						# grid['x, y'] = [lap, x, y, c, len], lap(2: 外形, 3: 色境界, 4: 同色)
		self[key = '%d, %d' % [x, y]] ? self[key][0] += (self[key][3] == c ? 2 : 1) : self[key] = [2, x, y, c, 1]
	end

	def remove_laps(remove_inner = false)
		self.each {|k, v|
			v[0] > (remove_inner ? 2 : 3) and self.delete(k)
		}
	end

	def join_lines(join_inner = false)
		self.keys.reverse.each {|k|
			cur = self[k]
			prv = self['%d, %d' % [cur[1] - @dx, cur[2] - @dy]]
			if(prv and (join_inner or cur[0] == prv[0]))
				prv[4] += cur[4]
				self.delete(k)
			end
		}
	end

	def line_each
		self.each {|xy, attr|
			yield(attr.object_id, attr[1], attr[2], attr[1] + attr[4] * @dx, attr[2] + attr[4] * @dy)
		}
	end
end

class OneStroker

	def initialize(hgrid, vgrid)
		@xys = {}; @lines = {}
#		hgrid.line_each {|line_id, x1, y1, x2, y2|
		hgrid.line_each {|line_id, x2, y2, x1, y1|				# 逆回り？
			@xys[xy1 = '%s, %s' % [x1, y1]] ||= []; 				@xys[xy2 = '%s, %s' % [x2, y2]] ||= []
			@xys[xy1] << line_id;									@xys[xy2] << line_id
			@lines['%s_%s' % [line_id, xy1]] = [line_id, x2, y2];	@lines['%s_%s' % [line_id, xy2]] = [line_id, x1, y1];	
		}
#		vgrid.line_each {|line_id, x1, y1, x2, y2|
		vgrid.line_each {|line_id, x2, y2, x1, y1|
			@xys[xy1 = '%s, %s' % [x1, y1]] ||= []; 				@xys[xy2 = '%s, %s' % [x2, y2]] ||= []
			@xys[xy1] << line_id;									@xys[xy2] << line_id
			@lines['%s_%s' % [line_id, xy1]] = [line_id, x2, y2];	@lines['%s_%s' % [line_id, xy2]] = [line_id, x1, y1];	
		}
	end

	def each
		line2another = nil; loop {

			@lines.size == 0 and break
			@lines[line2another] or line2another = @lines.keys[0]	# random? startpoint?

			lxy2 = @lines[line2another]; cur_line = lxy2[0]; ant_x = lxy2[1]; ant_y = lxy2[2]
			lxy1 = @lines[line2current = '%d_%s' % [cur_line, ant_xy = '%d, %d' % [ant_x, ant_y]]]; cur_x = lxy1[1]; cur_y = lxy1[2]

			yield(cur_line, cur_x, cur_y, ant_x, ant_y)
#			puts('cur_line %d (%d, %d)-(%d, %d)' % [cur_line, cur_x, cur_y, ant_x, ant_y])
			@lines.delete(line2another)
			@lines.delete(line2current)

			line2another = @xys[ant_xy].each {|line_id|
				@lines['%d_%s' % [line_id, ant_xy]] and break('%d_%s' % [line_id, ant_xy])
			}
		}
	end
end

hgrid = Grid.new(:H); vgrid = Grid.new(:V)

# すべてのドットを四角に線で囲む
ry = 0; pat.each {|hpat|
	rx = 0; hpat.each {|c|
		if(c < 8)
			hgrid.set(rx,     ry,     c)
			hgrid.set(rx,     ry + 1, c)
			vgrid.set(rx,     ry,     c)
			vgrid.set(rx + 1, ry,     c)
		end
		rx += 1
	}
	ry += 1
}

hgrid.remove_laps(opt_remove_inner);	vgrid.remove_laps(opt_remove_inner)		# 重なった線を削除する(内部の線も削除する)
hgrid.join_lines(opt_join_inner);		vgrid.join_lines(opt_join_inner)		# 隣り合う線をつなげる(内部の線もつなげる)

class Numeric
	def to_in
		self * 72 / 25.4
	end
end

# invader: (8 / 11 / 12dot) / 12mm

# 図化する
x0 = 8; y0 = 8; t = 1.0.to_in
unless(opt_one_stroke)

	hgrid.each {|k, v|
		win.line(xx = (x0 + v[1]) * t, yy = (y0 + v[2]) * t, xx + v[4] * t, yy, v[0] == 2 ? 0 : 2)
	}
	vgrid.each {|k, v|
		win.line(xx = (x0 + v[1]) * t, yy = (y0 + v[2]) * t, xx, yy + v[4] * t, v[0] == 2 ? 0 : 2)	# TODO: ちょっと余計に切る
	}
else
	_x0 =  0; _y0 =  0; _t = 1
#	_x0 = x0; _y0 = y0; _t = t

#	[560.5732283464566, 73.62204724409446]
#	[367.19999999999993, 350.0]

	_t = (560.5732283464566 - 367.19999999999993) / 256.0
	_x0 = 367.19999999999993 / _t; _y0 = 73.62204724409446 / _t

	ost = OneStroker.new(hgrid, vgrid)
	osts = []; ost.each {|c, x1, y1, x2, y2|
		win.line((x0 + x1) * t, (y0 + y1) * t, (x0 + x2) * t, (y0 + y2) * t, 2)
		puts("\t" * 2 + 'win.line(%12f, %12f, %12f, %12f, %d)' % [(_x0 + x1) * _t, (_y0 + y1) * _t, (_x0 + x2) * _t, (_y0 + y2) * _t, 2])
		osts << [c, x1, y1, x2, y2]
	}
end

win.refresh(60)									# ページ生成(pdf/ps)

win.getch
win.close

__END__

# convert -delay 20 -loop 0 -adjoin *.png anime.gif
Dir.mkdir('cutdot'); (0..osts.size).each {|limit|
	win = LegacyGraphics.new(0, 0, 0, 0,  150,  200, 16, 8, 7, { :file => 'cutdot/%04d' % limit, :type => 'png' })	# png/pdf/svg/ps
	n = 0; osts.each {|c, x1, y1, x2, y2|
		n == limit and break
		win.line((x0 + x1) * t, (y0 + y1) * t, (x0 + x2) * t, (y0 + y2) * t, 0); n += 1
	}
	win.refresh
	win.close
}

__END__

